/********************************************************************************
 *                     Original ThreadPool.java by Jeff Heaton                  *
 *                       Minor modifications by Andrew Maunder                  *
 *                                Aug 2004                                      *
 *******************************************************************************/

import java.net.*;
import java.io.*;
import java.util.*;

public class Pool {

    //protected Thread threads[] = null;
    protected Vector threads = null;
    Collection assignments = new ArrayList(3);
    protected Done done = new Done(); //the Done object

    public Pool ( int size ){

       //threads = new WorkerThread[size];
       threads = new Vector();

       for ( int i=0 ; i < size ; i++ ){
           threads.addElement(new WorkerThread(this));
           ((WorkerThread)threads.elementAt(i)).start();

       }//end of for loop

    }// pool constructor

    public synchronized void assign( Runnable r ){

        //if ( done.getActiveThreads() > threads.size() - 2 )
        //   incrPoolSize();
        done.workerBegin();
        assignments.add(r);
        notify();

    }//end of assign method

    public synchronized Runnable getAssignment(){

        try{
            while ( !assignments.iterator().hasNext() )
               wait();

            Runnable r = (Runnable)assignments.iterator().next();
            assignments.remove(r);

            return r;

        }catch ( InterruptedException e ){
           done.workerEnd();
           return null;
        }

    }//end of getAssignment method

    public void incrPoolSize() {

        threads.addElement(new WorkerThread(this));

    }//end of method to increase size of thread pool

    public void complete(){
     done.waitBegin();
     //done.waitDone();
    }

    protected void finalize(){

     done.reset();
     for ( int i = 0 ; i < threads.size() ; i++ ){
         ((WorkerThread)threads.elementAt(i)).interrupt();
         done.workerBegin();
         //threads[i].destroy();
     }
      done.waitDone();
    }

}// end of the queue class