/********************************************************************************
 *                                                                              *
 *               PoolServletThread.java written by Andrew Maunder               *
 *                     Department of Computer Science                           *
 *                        University of Cape Town                               *
 *                                Aug 2004                                      *
 *******************************************************************************/

import java.io.*;
import java.util.*;
import javax.servlet.*;
import java.io.*;
import java.net.*;
import java.lang.Thread;

public class PoolServletThread implements Runnable {

    /* The runnable interface allows an existing thread to execute this run method */

    private Request request;
    private Response response;
    private int lifeTime;
    private String init;
    private String identifier;
    private DataOutputStream out;
    private byte[] buffer;
    private Class myClass;
    private String uri;

    public PoolServletThread( String u, Class in, DataOutputStream o ){

    /* We initialise a servlet thread via the default constructor */
    out = o;
    myClass = in; // create a new class reference
    request = new Request();
    uri = request.parseUri(u);
    request.setUri(uri);
    response = new Response();
    response.setRequest(request);

    }// end of default constructor

    public void run( ){

     Servlet servlet = null; // create a new servlet reference

     try {
          servlet = (Servlet) myClass.newInstance();
          /* Set the new output stream of the response object */
          response.setOutputStream( out );
          /* Process the servlet */
          servlet.service((ServletRequest) request, (ServletResponse) response);
          /* The servlet has completed its processing */
          }
     catch (Exception e) {
      System.err.println("Servlet thread: " + e.toString());
     }
     catch (Throwable e) {
      System.err.println("Servlet thread: " + e.toString());
     }

    }//end of the run method

}//end of the java servlet thread class