/********************************************************************************
 *                                                                              *
 *               PoolServletThread.java written by Andrew Maunder               *
 *                     Department of Computer Science                           *
 *                        University of Cape Town                               *
 *                                Aug 2004                                      *
 *******************************************************************************/

import java.io.*;
import java.util.*;
import javax.servlet.*;
import java.io.*;
import java.net.*;
import java.lang.Thread;

public class ServletThread extends Thread {

    private Request request;
    private Response response;
    private String servletName;
    private URLClassLoader loader;
    private int lifeTime;

    public ServletThread( Request req, Response resp, String name, URLClassLoader cl ){
      /*Setup the servlet thread with the HTTP request data*/
      request = req;
      response = resp;
      servletName = name;
      loader = cl;
    }

    public void run( ){
     /* This method performs the work of the thread */

     Class myClass = null; // create a new class reference

     try {
           myClass = loader.loadClass(servletName); // dynamically load the class
     }
     catch (ClassNotFoundException e) {
           System.err.println(e);
     }

     Servlet servlet = null; // create a new servlet reference

     try {
          servlet = (Servlet) myClass.newInstance();
          /* Set the new output stream of the response object */
          response.setOutputStream( System.out );
          /* Process the servlet */
          servlet.service((ServletRequest) request, (ServletResponse) response);
          /* The servlet has completed its processing */
         }
     catch (Exception e) {
      System.err.println("Servlet thread: " + e.toString());
     }
     catch (Throwable e) {
      System.err.println("Servlet thread: " + e.toString());
     }

    }//end of the run method

}//end of the java servlet thread class