/***************************************************************************
 *   Copyright (C) 2004 by Reinhardt van Rooyen                            *
 *   rvanrooy@cs.uct.ac.za						   *			
 *  									   *
 *   The xSwitch program is the intellectual property of Andrew Maunder    *
 *   and Reinhardt van Rooyen, along with with computer science department *  
 *   at the University of Cape Town                                        *
 *									   *	
 *   This is part of the xSwitch honours project by the authors            *                                     *
 *                                                                         *
 ***************************************************************************/
#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <pwd.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>






void *listen_for_child( void *ptr );
void *info_listen_for_child( void *ptr );
void *thread_control( void *ptr );
int getUserUID(char * name);
char * getUserPath(char * name);

#define OUTPUT_LENGTH 1024
#define MAX_LENGTH 64
#define USER_LENGTH 20
#define ENGINE_TYPE_LENGTH 20
#define TIMEOUT_VALUE 3
#define GO 1
#define CONTINUE 1
#define STOP 0
#define Engine struct engine
#define PHP 0
#define JAVA 1
#define PERL 2

#define TRUE 1
#define FALSE 0

#define STATUS_BUSY 0
#define STATUS_READY 1
#define STATUS_MFD 2
#define STATUS_DELETED 3

#define BACKLOG 10     // how many pending connections queue will hold


int threadExit = 0;
int createEngine = TRUE;

struct engine
{

	int numEngines;
	
	
	//int containing sockect to send reply back to
	int currentRequestSocket;
	
	
	//communication between processes
	int scktpair[2];
	FILE * inputPointer;
	
	//variables set for receiving response from child
	char responeMessage[OUTPUT_LENGTH];
	size_t lenOfResponseMessage;
	ssize_t numOfCharsRead;
	
	//thread for engine output
	pthread_t engineThread;
	int  threadCreateValue;
	
	pthread_t engineThreadControl;
	int  controlThreadCreateValue;
	

	//ID of engine as incremental int
	int id;
	//type of engine
	char type[ENGINE_TYPE_LENGTH];
	//the status of engine
	int status;
	//the user who owns the process
	char owner[USER_LENGTH];
	//the uid of the owner who owns the process
	int uid;
	//the path to the users directory where the files are stored
	char path[MAX_LENGTH];
	//the counter for processing requests
	int counter;
	
	Engine *nextEngine;
};
